<?php

function check_username($name)
{
	global $EGN, $LANG;
	$name = trim($name);
	if(get_magic_quotes_gpc())$name = stripslashes($name);

	if(strlen($name)<2)
	{
		$EGN['errors'] .= $LANG['err_nameshort'];
	}
	elseif(strlen($name)>16)
	{
		$EGN['errors'] .= $LANG['err_namelong'];
	}

	$search = array('  ', '<', '>', "'", '"', '|', "\r", "\n", '&');
	$replace = array(' ', '&lt;', '&gt;', '&#39;', '&quot;', '&#124;', '', '', '&amp;');
	$name = str_replace($search, $replace, $name);
	return $name;
}

function check_text($text)
{
	global $EGN, $CFG, $LANG;
	$text = trim($text);
	if(get_magic_quotes_gpc())$text = stripslashes($text);
	if (strlen($text) < $CFG['msg_min'])
	{
		$EGN['errors'] .= sprintf($LANG['err_textshort'], $CFG['msg_min']);
	}
	elseif (strlen($text) > $CFG['msg_max'])
	{
		$EGN['errors'] .= sprintf($LANG['err_textlong'], $CFG['msg_max']);
	}
	else
	{
		$smcount = 0;
        foreach ($EGN['smiles'] as $smcode => $smfile)
        {
            $sc =  substr_count($text, $smcode);
            $smcount += $sc;
        }
        if($smcount > $CFG['smpm'])
        {
        	$EGN['errors'] .= sprintf($LANG['err_smiletoomany'], $CFG['smpm']);
        }
	}
	$text = str_replace("\r", '', $text);
	$text = str_replace("\n\n\n", "\n\n", $text);
	$text = str_replace('  ', ' ', $text);
	$text = str_replace('&', '&amp;', $text);
	$search = array('<', '>', "'", '"', '|', "\n");
	$replace = array('&lt;', '&gt;', '&#39;', '&quot;', '&#124;', '<br />');
	$text = str_replace($search, $replace, $text);
	return $text;
}

function check_answer($answer)
{
	global $CFG;
	$answer = trim($answer);
	if(get_magic_quotes_gpc())$answer = stripslashes($answer);
	if(!$CFG['htmlanswer'])
	{
	    $search = array('<', '>', "'", '"');
	    $replace = array('&lt;', '&gt;', '&#39;', '&quot;');
	    $answer = str_replace($search, $replace, $answer);
	    $answer = str_replace("\r", '', $answer);
	    $answer = str_replace("\n", '<br />', $answer);
	}
	else
	{
	    $answer = str_replace("|", '&#124;', $answer);
	    $answer = str_replace("\r", '', $answer);
	    $answer = str_replace("\n", '', $answer);
	}
	return $answer;
}

function check_url($url)
{
	global $EGN, $LANG;
	$url = strtolower(trim($url));
	if ($url != '')
	{
	    if( !preg_match("#^([a-z\.\-_:\/]+[a-z]{2,4})$#", $url) || ( strlen($url) > 64 ) )
	    {
	        $EGN['errors'] .= $LANG['err_urlnotvalid'];
	        $url = '';
	    }
	    elseif ( !eregi('http://', $url) )
	    {
	    	$url = 'http://'.$url;
	    }
	}
	return $url;
}
function check_email($email)
{
	global $EGN, $LANG;
	$email = strtolower(trim($email));
	if ($email != '')
	{
	    if( !preg_match('#^([a-z0-9_\-]+@[a-z0-9_\-]+\.[a-z0-9_\-]{2,4})$#', $email) || (strlen($email) > 64))
	    {
	        $EGN['errors'] .= $LANG['err_emailnotvalid'];
	        $email = '';
	    }
	}
	return $email;
}
function check_icq($icq)
{
	global $EGN, $LANG;
	$icq = trim($icq);
	if ($icq != '')
	{
	    if ( !is_numeric($icq) || strlen($icq) > 11 )
	    {
	        $EGN['errors'] .= $LANG['err_icqnotvalid'];
	        $icq = '';
	    }
	}
	return $icq;
}

function check_city($city)
{
	global $EGN, $LANG;
	$city = trim($city);
	if(get_magic_quotes_gpc())$city = stripslashes($city);
	if ($city != '')
	{
	    if ( strlen($city) < 2 )
	    {
	        $EGN['errors'] .= $LANG['err_cityshort'];
	    }
	    elseif ( strlen($city) > 20 )
	    {
	        $EGN['errors'] .= $LANG['err_citylong'];
	    }
	    $search = array('  ', '<', '>', "'", '"', '|', "\r", "\n", '&');
	    $replace = array(' ', '&lt;', '&gt;', '&#39;', '&quot;', '&#124;', '', '', '&amp;');
	    $city = str_replace($search, $replace, $city);
	}
	return $city;
}

function check_ip($ip, $addtime)
{
	global $EGN, $CFG, $LANG;
	$ip = trim($ip);
    $mass = @file( $CFG['dbname'] );
    @list(, , , , , , $paddtime, , , $pip) = explode("|", $mass[0]);
    if ( !strcmp($ip, $pip) && ( ($addtime - $paddtime) < $CFG['stoptime'] ) )
    {
        $EGN['errors'] .= sprintf($LANG['err_antispam'], $CFG['stoptime']);
    }
    $ipban = @file( 'ipban.dat' );
    foreach ($ipban as $mask)
    {
    	$mask = trim($mask);
        $mask = str_replace('*','[0-9]*', $mask);
        $mask = str_replace('.','\.', $mask);
        if ( preg_match("#^(".$mask.")$#", $ip) )
        {
            $EGN['errors'] .= $LANG['err_ipbanned'];
            break;
        }
    }
	return $ip;
}

function check_capcha($capcha)
{
	global $EGN, $LANG;

	$capcha = trim($capcha);

	if ($capcha != '' && is_numeric($capcha) && isset($_SESSION['capcha']) && $_SESSION['capcha'] == $capcha)return '';

	$EGN['errors'] .= $LANG['err_capchanotvalid'];
	return '';
}
?>